/**
 * Generated by @openapi-codegen
 *
 * @version 1.0.0
 */
import * as reactQuery from 'react-query'
import { useAdaliaIdContext, AdaliaIdContext } from './adaliaIdContext'
import { adaliaIdFetch } from './adaliaIdFetcher'
import type * as Schemas from './adaliaIdSchemas'

export type RootRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type RootRetrieveVariables = {
  queryParams?: RootRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchRootRetrieve = (variables: RootRetrieveVariables) =>
  adaliaIdFetch<undefined, undefined, {}, RootRetrieveQueryParams, {}>({
    url: '/api/',
    method: 'get',
    ...variables,
  })

export const useRootRetrieve = (
  variables: RootRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<undefined, undefined, undefined>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<undefined, undefined, undefined>(
    queryKeyFn({ path: '/api/', operationId: 'rootRetrieve', variables }),
    () => fetchRootRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdAsteroidsListQueryParams = {
  alliance_controlled?: boolean
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  anomaly_max?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  anomaly_min?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  ascending_node_max?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  ascending_node_min?: number | null
  current_owner?: string
  /*
   * @maximum 750284
   * @minimum 2046
   */
  diameter_max?: number | null
  /*
   * @maximum 750284
   * @minimum 2046
   */
  diameter_min?: number | null
  /*
   * @format double
   * @maximum 0.392
   * @minimum 0.007
   */
  eccentricity_max?: number | null
  /*
   * @format double
   * @maximum 0.392
   * @minimum 0.007
   */
  eccentricity_min?: number | null
  format?: 'csv' | 'datatables' | 'json'
  /*
   * @format double
   * @maximum 37.77
   * @minimum 0.01
   */
  inclination_max?: number | null
  /*
   * @format double
   * @maximum 37.77
   * @minimum 0.01
   */
  inclination_min?: number | null
  /*
   * Number of results to return per page.
   */
  limit?: number
  name?: string
  /*
   * The initial index from which to return the results.
   */
  offset?: number
  /*
   * @format double
   * @maximum 10000
   * @minimum 0
   * @exclusiveMaximum true
   */
  orbital_period_max?: number | null
  /*
   * @format double
   * @maximum 10000
   * @minimum 0
   * @exclusiveMaximum true
   */
  orbital_period_min?: number | null
  /*
   * Ordering
   */
  ordering?: (
    | '-anomaly'
    | '-ascending_node'
    | '-current_owner'
    | '-diameter'
    | '-eccentricity'
    | '-inclination'
    | '-name'
    | '-orbital_period'
    | '-periapsis'
    | '-semi_major_axis'
    | '-serial'
    | 'anomaly'
    | 'ascending_node'
    | 'current_owner'
    | 'diameter'
    | 'eccentricity'
    | 'inclination'
    | 'name'
    | 'orbital_period'
    | 'periapsis'
    | 'semi_major_axis'
    | 'serial'
  )[]
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  periapsis_max?: number | null
  /*
   * @format double
   * @maximum 1000
   * @minimum -1000
   * @exclusiveMaximum true
   * @exclusiveMinimum true
   */
  periapsis_min?: number | null
  /*
   * @format double
   * @maximum 3.913
   * @minimum 0.89
   */
  semi_major_axis_max?: number | null
  /*
   * @format double
   * @maximum 3.913
   * @minimum 0.89
   */
  semi_major_axis_min?: number | null
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial_max?: number
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial_min?: number
  user_owned?: boolean
}

export type AdaliaIdAsteroidsListVariables = {
  queryParams?: AdaliaIdAsteroidsListQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdAsteroidsList = (
  variables: AdaliaIdAsteroidsListVariables
) =>
  adaliaIdFetch<
    Schemas.PaginatedAsteroidList,
    undefined,
    {},
    AdaliaIdAsteroidsListQueryParams,
    {}
  >({ url: '/api/adalia_id/asteroids/', method: 'get', ...variables })

export const useAdaliaIdAsteroidsList = (
  variables: AdaliaIdAsteroidsListVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<
      Schemas.PaginatedAsteroidList,
      undefined,
      Schemas.PaginatedAsteroidList
    >,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<
    Schemas.PaginatedAsteroidList,
    undefined,
    Schemas.PaginatedAsteroidList
  >(
    queryKeyFn({
      path: '/api/adalia_id/asteroids/',
      operationId: 'adaliaIdAsteroidsList',
      variables,
    }),
    () => fetchAdaliaIdAsteroidsList({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdAsteroidsRetrievePathParams = {
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial: number
}

export type AdaliaIdAsteroidsRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdAsteroidsRetrieveVariables = {
  pathParams: AdaliaIdAsteroidsRetrievePathParams
  queryParams?: AdaliaIdAsteroidsRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdAsteroidsRetrieve = (
  variables: AdaliaIdAsteroidsRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Asteroid,
    undefined,
    {},
    AdaliaIdAsteroidsRetrieveQueryParams,
    AdaliaIdAsteroidsRetrievePathParams
  >({ url: '/api/adalia_id/asteroids/{serial}/', method: 'get', ...variables })

export const useAdaliaIdAsteroidsRetrieve = (
  variables: AdaliaIdAsteroidsRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Asteroid, undefined, Schemas.Asteroid>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Asteroid, undefined, Schemas.Asteroid>(
    queryKeyFn({
      path: '/api/adalia_id/asteroids/{serial}/',
      operationId: 'adaliaIdAsteroidsRetrieve',
      variables,
    }),
    () => fetchAdaliaIdAsteroidsRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdAsteroidsAllianceControlRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdAsteroidsAllianceControlRetrieveVariables = {
  queryParams?: AdaliaIdAsteroidsAllianceControlRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdAsteroidsAllianceControlRetrieve = (
  variables: AdaliaIdAsteroidsAllianceControlRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Asteroid,
    undefined,
    {},
    AdaliaIdAsteroidsAllianceControlRetrieveQueryParams,
    {}
  >({
    url: '/api/adalia_id/asteroids/alliance_control/',
    method: 'get',
    ...variables,
  })

export const useAdaliaIdAsteroidsAllianceControlRetrieve = (
  variables: AdaliaIdAsteroidsAllianceControlRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Asteroid, undefined, Schemas.Asteroid>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Asteroid, undefined, Schemas.Asteroid>(
    queryKeyFn({
      path: '/api/adalia_id/asteroids/alliance_control/',
      operationId: 'adaliaIdAsteroidsAllianceControlRetrieve',
      variables,
    }),
    () =>
      fetchAdaliaIdAsteroidsAllianceControlRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdAsteroidsEarlyAdopterRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdAsteroidsEarlyAdopterRetrieveVariables = {
  queryParams?: AdaliaIdAsteroidsEarlyAdopterRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdAsteroidsEarlyAdopterRetrieve = (
  variables: AdaliaIdAsteroidsEarlyAdopterRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Asteroid,
    undefined,
    {},
    AdaliaIdAsteroidsEarlyAdopterRetrieveQueryParams,
    {}
  >({
    url: '/api/adalia_id/asteroids/early_adopter/',
    method: 'get',
    ...variables,
  })

export const useAdaliaIdAsteroidsEarlyAdopterRetrieve = (
  variables: AdaliaIdAsteroidsEarlyAdopterRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Asteroid, undefined, Schemas.Asteroid>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Asteroid, undefined, Schemas.Asteroid>(
    queryKeyFn({
      path: '/api/adalia_id/asteroids/early_adopter/',
      operationId: 'adaliaIdAsteroidsEarlyAdopterRetrieve',
      variables,
    }),
    () =>
      fetchAdaliaIdAsteroidsEarlyAdopterRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdAsteroidsPersonalRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdAsteroidsPersonalRetrieveVariables = {
  queryParams?: AdaliaIdAsteroidsPersonalRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdAsteroidsPersonalRetrieve = (
  variables: AdaliaIdAsteroidsPersonalRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Asteroid,
    undefined,
    {},
    AdaliaIdAsteroidsPersonalRetrieveQueryParams,
    {}
  >({ url: '/api/adalia_id/asteroids/personal/', method: 'get', ...variables })

export const useAdaliaIdAsteroidsPersonalRetrieve = (
  variables: AdaliaIdAsteroidsPersonalRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Asteroid, undefined, Schemas.Asteroid>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Asteroid, undefined, Schemas.Asteroid>(
    queryKeyFn({
      path: '/api/adalia_id/asteroids/personal/',
      operationId: 'adaliaIdAsteroidsPersonalRetrieve',
      variables,
    }),
    () =>
      fetchAdaliaIdAsteroidsPersonalRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdAsteroidsSummaryRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdAsteroidsSummaryRetrieveVariables = {
  queryParams?: AdaliaIdAsteroidsSummaryRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdAsteroidsSummaryRetrieve = (
  variables: AdaliaIdAsteroidsSummaryRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Asteroid,
    undefined,
    {},
    AdaliaIdAsteroidsSummaryRetrieveQueryParams,
    {}
  >({ url: '/api/adalia_id/asteroids/summary/', method: 'get', ...variables })

export const useAdaliaIdAsteroidsSummaryRetrieve = (
  variables: AdaliaIdAsteroidsSummaryRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Asteroid, undefined, Schemas.Asteroid>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Asteroid, undefined, Schemas.Asteroid>(
    queryKeyFn({
      path: '/api/adalia_id/asteroids/summary/',
      operationId: 'adaliaIdAsteroidsSummaryRetrieve',
      variables,
    }),
    () =>
      fetchAdaliaIdAsteroidsSummaryRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdCrewmatesListQueryParams = {
  alliance_controlled?: boolean
  collection?: number
  current_owner?: string
  description?: string
  format?: 'csv' | 'datatables' | 'json'
  image_url?: string
  /*
   * Number of results to return per page.
   */
  limit?: number
  name?: string
  /*
   * The initial index from which to return the results.
   */
  offset?: number
  polymorphic_ctype?: number
  profile?: string
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial_max?: number
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial_min?: number
  user_owned?: boolean
}

export type AdaliaIdCrewmatesListVariables = {
  queryParams?: AdaliaIdCrewmatesListQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdCrewmatesList = (
  variables: AdaliaIdCrewmatesListVariables
) =>
  adaliaIdFetch<
    Schemas.PaginatedCrewmateList,
    undefined,
    {},
    AdaliaIdCrewmatesListQueryParams,
    {}
  >({ url: '/api/adalia_id/crewmates/', method: 'get', ...variables })

export const useAdaliaIdCrewmatesList = (
  variables: AdaliaIdCrewmatesListVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<
      Schemas.PaginatedCrewmateList,
      undefined,
      Schemas.PaginatedCrewmateList
    >,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<
    Schemas.PaginatedCrewmateList,
    undefined,
    Schemas.PaginatedCrewmateList
  >(
    queryKeyFn({
      path: '/api/adalia_id/crewmates/',
      operationId: 'adaliaIdCrewmatesList',
      variables,
    }),
    () => fetchAdaliaIdCrewmatesList({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdCrewmatesRetrievePathParams = {
  /*
   * @maximum 9223372036854776000
   * @minimum 0
   * @format int64
   */
  serial: number
}

export type AdaliaIdCrewmatesRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdCrewmatesRetrieveVariables = {
  pathParams: AdaliaIdCrewmatesRetrievePathParams
  queryParams?: AdaliaIdCrewmatesRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdCrewmatesRetrieve = (
  variables: AdaliaIdCrewmatesRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Crewmate,
    undefined,
    {},
    AdaliaIdCrewmatesRetrieveQueryParams,
    AdaliaIdCrewmatesRetrievePathParams
  >({ url: '/api/adalia_id/crewmates/{serial}/', method: 'get', ...variables })

export const useAdaliaIdCrewmatesRetrieve = (
  variables: AdaliaIdCrewmatesRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Crewmate, undefined, Schemas.Crewmate>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Crewmate, undefined, Schemas.Crewmate>(
    queryKeyFn({
      path: '/api/adalia_id/crewmates/{serial}/',
      operationId: 'adaliaIdCrewmatesRetrieve',
      variables,
    }),
    () => fetchAdaliaIdCrewmatesRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdCrewmatesAllianceControlRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdCrewmatesAllianceControlRetrieveVariables = {
  queryParams?: AdaliaIdCrewmatesAllianceControlRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdCrewmatesAllianceControlRetrieve = (
  variables: AdaliaIdCrewmatesAllianceControlRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Crewmate,
    undefined,
    {},
    AdaliaIdCrewmatesAllianceControlRetrieveQueryParams,
    {}
  >({
    url: '/api/adalia_id/crewmates/alliance_control/',
    method: 'get',
    ...variables,
  })

export const useAdaliaIdCrewmatesAllianceControlRetrieve = (
  variables: AdaliaIdCrewmatesAllianceControlRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Crewmate, undefined, Schemas.Crewmate>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Crewmate, undefined, Schemas.Crewmate>(
    queryKeyFn({
      path: '/api/adalia_id/crewmates/alliance_control/',
      operationId: 'adaliaIdCrewmatesAllianceControlRetrieve',
      variables,
    }),
    () =>
      fetchAdaliaIdCrewmatesAllianceControlRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AdaliaIdCrewmatesPersonalRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AdaliaIdCrewmatesPersonalRetrieveVariables = {
  queryParams?: AdaliaIdCrewmatesPersonalRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAdaliaIdCrewmatesPersonalRetrieve = (
  variables: AdaliaIdCrewmatesPersonalRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Crewmate,
    undefined,
    {},
    AdaliaIdCrewmatesPersonalRetrieveQueryParams,
    {}
  >({ url: '/api/adalia_id/crewmates/personal/', method: 'get', ...variables })

export const useAdaliaIdCrewmatesPersonalRetrieve = (
  variables: AdaliaIdCrewmatesPersonalRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Crewmate, undefined, Schemas.Crewmate>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Crewmate, undefined, Schemas.Crewmate>(
    queryKeyFn({
      path: '/api/adalia_id/crewmates/personal/',
      operationId: 'adaliaIdCrewmatesPersonalRetrieve',
      variables,
    }),
    () =>
      fetchAdaliaIdCrewmatesPersonalRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AuthUsersListQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
  /*
   * Number of results to return per page.
   */
  limit?: number
  /*
   * The initial index from which to return the results.
   */
  offset?: number
}

export type AuthUsersListVariables = {
  queryParams?: AuthUsersListQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAuthUsersList = (variables: AuthUsersListVariables) =>
  adaliaIdFetch<
    Schemas.PaginatedUserList,
    undefined,
    {},
    AuthUsersListQueryParams,
    {}
  >({ url: '/api/auth/users/', method: 'get', ...variables })

export const useAuthUsersList = (
  variables: AuthUsersListVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<
      Schemas.PaginatedUserList,
      undefined,
      Schemas.PaginatedUserList
    >,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<
    Schemas.PaginatedUserList,
    undefined,
    Schemas.PaginatedUserList
  >(
    queryKeyFn({
      path: '/api/auth/users/',
      operationId: 'authUsersList',
      variables,
    }),
    () => fetchAuthUsersList({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AuthUsersRetrievePathParams = {
  username: string
}

export type AuthUsersRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AuthUsersRetrieveVariables = {
  pathParams: AuthUsersRetrievePathParams
  queryParams?: AuthUsersRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAuthUsersRetrieve = (variables: AuthUsersRetrieveVariables) =>
  adaliaIdFetch<
    Schemas.User,
    undefined,
    {},
    AuthUsersRetrieveQueryParams,
    AuthUsersRetrievePathParams
  >({ url: '/api/auth/users/{username}/', method: 'get', ...variables })

export const useAuthUsersRetrieve = (
  variables: AuthUsersRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.User, undefined, Schemas.User>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.User, undefined, Schemas.User>(
    queryKeyFn({
      path: '/api/auth/users/{username}/',
      operationId: 'authUsersRetrieve',
      variables,
    }),
    () => fetchAuthUsersRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type AuthUsersUpdatePathParams = {
  username: string
}

export type AuthUsersUpdateQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AuthUsersUpdateVariables = {
  body: Schemas.User
  pathParams: AuthUsersUpdatePathParams
  queryParams?: AuthUsersUpdateQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAuthUsersUpdate = (variables: AuthUsersUpdateVariables) =>
  adaliaIdFetch<
    Schemas.User,
    Schemas.User,
    {},
    AuthUsersUpdateQueryParams,
    AuthUsersUpdatePathParams
  >({ url: '/api/auth/users/{username}/', method: 'put', ...variables })

export const useAuthUsersUpdate = (
  options?: Omit<
    reactQuery.UseMutationOptions<
      Schemas.User,
      undefined,
      AuthUsersUpdateVariables
    >,
    'mutationFn'
  >
) => {
  const { fetcherOptions } = useAdaliaIdContext()
  return reactQuery.useMutation<
    Schemas.User,
    undefined,
    AuthUsersUpdateVariables
  >(
    (variables: AuthUsersUpdateVariables) =>
      fetchAuthUsersUpdate({ ...fetcherOptions, ...variables }),
    options
  )
}

export type AuthUsersPartialUpdatePathParams = {
  username: string
}

export type AuthUsersPartialUpdateQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type AuthUsersPartialUpdateVariables = {
  body?: Schemas.PatchedUser
  pathParams: AuthUsersPartialUpdatePathParams
  queryParams?: AuthUsersPartialUpdateQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchAuthUsersPartialUpdate = (
  variables: AuthUsersPartialUpdateVariables
) =>
  adaliaIdFetch<
    Schemas.User,
    Schemas.PatchedUser,
    {},
    AuthUsersPartialUpdateQueryParams,
    AuthUsersPartialUpdatePathParams
  >({ url: '/api/auth/users/{username}/', method: 'patch', ...variables })

export const useAuthUsersPartialUpdate = (
  options?: Omit<
    reactQuery.UseMutationOptions<
      Schemas.User,
      undefined,
      AuthUsersPartialUpdateVariables
    >,
    'mutationFn'
  >
) => {
  const { fetcherOptions } = useAdaliaIdContext()
  return reactQuery.useMutation<
    Schemas.User,
    undefined,
    AuthUsersPartialUpdateVariables
  >(
    (variables: AuthUsersPartialUpdateVariables) =>
      fetchAuthUsersPartialUpdate({ ...fetcherOptions, ...variables }),
    options
  )
}

export type LoginCreateQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type LoginCreateVariables = {
  body: Schemas.JSONWebToken
  queryParams?: LoginCreateQueryParams
} & AdaliaIdContext['fetcherOptions']

/**
 * API View that receives a POST with a user's username and password.
 *
 * Returns a JSON Web Token that can be used for authenticated requests.
 */
export const fetchLoginCreate = (variables: LoginCreateVariables) =>
  adaliaIdFetch<
    Schemas.JSONWebToken,
    Schemas.JSONWebToken,
    {},
    LoginCreateQueryParams,
    {}
  >({ url: '/api/login', method: 'post', ...variables })

/**
 * API View that receives a POST with a user's username and password.
 *
 * Returns a JSON Web Token that can be used for authenticated requests.
 */
export const useLoginCreate = (
  options?: Omit<
    reactQuery.UseMutationOptions<
      Schemas.JSONWebToken,
      undefined,
      LoginCreateVariables
    >,
    'mutationFn'
  >
) => {
  const { fetcherOptions } = useAdaliaIdContext()
  return reactQuery.useMutation<
    Schemas.JSONWebToken,
    undefined,
    LoginCreateVariables
  >(
    (variables: LoginCreateVariables) =>
      fetchLoginCreate({ ...fetcherOptions, ...variables }),
    options
  )
}

export type NftsAssetsListPathParams = {
  /*
   * @pattern ^[A-Z]+$
   */
  collection: string
}

export type NftsAssetsListQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
  /*
   * Number of results to return per page.
   */
  limit?: number
  /*
   * The initial index from which to return the results.
   */
  offset?: number
}

export type NftsAssetsListVariables = {
  pathParams: NftsAssetsListPathParams
  queryParams?: NftsAssetsListQueryParams
} & AdaliaIdContext['fetcherOptions']

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const fetchNftsAssetsList = (variables: NftsAssetsListVariables) =>
  adaliaIdFetch<
    Schemas.PaginatedNFTAssetList,
    undefined,
    {},
    NftsAssetsListQueryParams,
    NftsAssetsListPathParams
  >({ url: '/api/nfts/{collection}/assets/', method: 'get', ...variables })

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const useNftsAssetsList = (
  variables: NftsAssetsListVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<
      Schemas.PaginatedNFTAssetList,
      undefined,
      Schemas.PaginatedNFTAssetList
    >,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<
    Schemas.PaginatedNFTAssetList,
    undefined,
    Schemas.PaginatedNFTAssetList
  >(
    queryKeyFn({
      path: '/api/nfts/{collection}/assets/',
      operationId: 'nftsAssetsList',
      variables,
    }),
    () => fetchNftsAssetsList({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type NftsAssetsRetrievePathParams = {
  /*
   * @pattern ^[A-Z]+$
   */
  collection: string
  serial: string
}

export type NftsAssetsRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type NftsAssetsRetrieveVariables = {
  pathParams: NftsAssetsRetrievePathParams
  queryParams?: NftsAssetsRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const fetchNftsAssetsRetrieve = (
  variables: NftsAssetsRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.NFTAsset,
    undefined,
    {},
    NftsAssetsRetrieveQueryParams,
    NftsAssetsRetrievePathParams
  >({
    url: '/api/nfts/{collection}/assets/{serial}/',
    method: 'get',
    ...variables,
  })

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const useNftsAssetsRetrieve = (
  variables: NftsAssetsRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.NFTAsset, undefined, Schemas.NFTAsset>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.NFTAsset, undefined, Schemas.NFTAsset>(
    queryKeyFn({
      path: '/api/nfts/{collection}/assets/{serial}/',
      operationId: 'nftsAssetsRetrieve',
      variables,
    }),
    () => fetchNftsAssetsRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type NftsAssetsAllianceControlRetrievePathParams = {
  /*
   * @pattern ^[A-Z]+$
   */
  collection: string
}

export type NftsAssetsAllianceControlRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type NftsAssetsAllianceControlRetrieveVariables = {
  pathParams: NftsAssetsAllianceControlRetrievePathParams
  queryParams?: NftsAssetsAllianceControlRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const fetchNftsAssetsAllianceControlRetrieve = (
  variables: NftsAssetsAllianceControlRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.NFTAsset,
    undefined,
    {},
    NftsAssetsAllianceControlRetrieveQueryParams,
    NftsAssetsAllianceControlRetrievePathParams
  >({
    url: '/api/nfts/{collection}/assets/alliance_control/',
    method: 'get',
    ...variables,
  })

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const useNftsAssetsAllianceControlRetrieve = (
  variables: NftsAssetsAllianceControlRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.NFTAsset, undefined, Schemas.NFTAsset>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.NFTAsset, undefined, Schemas.NFTAsset>(
    queryKeyFn({
      path: '/api/nfts/{collection}/assets/alliance_control/',
      operationId: 'nftsAssetsAllianceControlRetrieve',
      variables,
    }),
    () =>
      fetchNftsAssetsAllianceControlRetrieve({
        ...fetcherOptions,
        ...variables,
      }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type NftsAssetsPersonalRetrievePathParams = {
  /*
   * @pattern ^[A-Z]+$
   */
  collection: string
}

export type NftsAssetsPersonalRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type NftsAssetsPersonalRetrieveVariables = {
  pathParams: NftsAssetsPersonalRetrievePathParams
  queryParams?: NftsAssetsPersonalRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const fetchNftsAssetsPersonalRetrieve = (
  variables: NftsAssetsPersonalRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.NFTAsset,
    undefined,
    {},
    NftsAssetsPersonalRetrieveQueryParams,
    NftsAssetsPersonalRetrievePathParams
  >({
    url: '/api/nfts/{collection}/assets/personal/',
    method: 'get',
    ...variables,
  })

/**
 * This viewset automatically provides `list` and `retrieve` actions.
 */
export const useNftsAssetsPersonalRetrieve = (
  variables: NftsAssetsPersonalRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.NFTAsset, undefined, Schemas.NFTAsset>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.NFTAsset, undefined, Schemas.NFTAsset>(
    queryKeyFn({
      path: '/api/nfts/{collection}/assets/personal/',
      operationId: 'nftsAssetsPersonalRetrieve',
      variables,
    }),
    () => fetchNftsAssetsPersonalRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type RefreshCreateQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type RefreshCreateVariables = {
  body: Schemas.RefreshAuthToken
  queryParams?: RefreshCreateQueryParams
} & AdaliaIdContext['fetcherOptions']

/**
 * API View that returns a refreshed token (with new expiration) based on
 * existing token
 *
 * If 'orig_iat' field (original issued-at-time) is found it will first check
 * if it's within expiration window, then copy it to the new token.
 */
export const fetchRefreshCreate = (variables: RefreshCreateVariables) =>
  adaliaIdFetch<
    Schemas.RefreshAuthToken,
    Schemas.RefreshAuthToken,
    {},
    RefreshCreateQueryParams,
    {}
  >({ url: '/api/refresh', method: 'post', ...variables })

/**
 * API View that returns a refreshed token (with new expiration) based on
 * existing token
 *
 * If 'orig_iat' field (original issued-at-time) is found it will first check
 * if it's within expiration window, then copy it to the new token.
 */
export const useRefreshCreate = (
  options?: Omit<
    reactQuery.UseMutationOptions<
      Schemas.RefreshAuthToken,
      undefined,
      RefreshCreateVariables
    >,
    'mutationFn'
  >
) => {
  const { fetcherOptions } = useAdaliaIdContext()
  return reactQuery.useMutation<
    Schemas.RefreshAuthToken,
    undefined,
    RefreshCreateVariables
  >(
    (variables: RefreshCreateVariables) =>
      fetchRefreshCreate({ ...fetcherOptions, ...variables }),
    options
  )
}

export type WalletsWalletsListQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
  /*
   * Number of results to return per page.
   */
  limit?: number
  /*
   * The initial index from which to return the results.
   */
  offset?: number
}

export type WalletsWalletsListVariables = {
  queryParams?: WalletsWalletsListQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchWalletsWalletsList = (
  variables: WalletsWalletsListVariables
) =>
  adaliaIdFetch<
    Schemas.PaginatedWalletList,
    undefined,
    {},
    WalletsWalletsListQueryParams,
    {}
  >({ url: '/api/wallets/wallets/', method: 'get', ...variables })

export const useWalletsWalletsList = (
  variables: WalletsWalletsListVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<
      Schemas.PaginatedWalletList,
      undefined,
      Schemas.PaginatedWalletList
    >,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<
    Schemas.PaginatedWalletList,
    undefined,
    Schemas.PaginatedWalletList
  >(
    queryKeyFn({
      path: '/api/wallets/wallets/',
      operationId: 'walletsWalletsList',
      variables,
    }),
    () => fetchWalletsWalletsList({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type WalletsWalletsRetrievePathParams = {
  id: string
}

export type WalletsWalletsRetrieveQueryParams = {
  format?: 'csv' | 'datatables' | 'json'
}

export type WalletsWalletsRetrieveVariables = {
  pathParams: WalletsWalletsRetrievePathParams
  queryParams?: WalletsWalletsRetrieveQueryParams
} & AdaliaIdContext['fetcherOptions']

export const fetchWalletsWalletsRetrieve = (
  variables: WalletsWalletsRetrieveVariables
) =>
  adaliaIdFetch<
    Schemas.Wallet,
    undefined,
    {},
    WalletsWalletsRetrieveQueryParams,
    WalletsWalletsRetrievePathParams
  >({ url: '/api/wallets/wallets/{id}/', method: 'get', ...variables })

export const useWalletsWalletsRetrieve = (
  variables: WalletsWalletsRetrieveVariables,
  options?: Omit<
    reactQuery.UseQueryOptions<Schemas.Wallet, undefined, Schemas.Wallet>,
    'queryKey' | 'queryFn'
  >
) => {
  const { fetcherOptions, queryOptions, queryKeyFn } =
    useAdaliaIdContext(options)
  return reactQuery.useQuery<Schemas.Wallet, undefined, Schemas.Wallet>(
    queryKeyFn({
      path: '/api/wallets/wallets/{id}/',
      operationId: 'walletsWalletsRetrieve',
      variables,
    }),
    () => fetchWalletsWalletsRetrieve({ ...fetcherOptions, ...variables }),
    {
      ...options,
      ...queryOptions,
    }
  )
}

export type QueryOperation =
  | {
      path: '/api/'
      operationId: 'rootRetrieve'
      variables: RootRetrieveVariables
    }
  | {
      path: '/api/adalia_id/asteroids/'
      operationId: 'adaliaIdAsteroidsList'
      variables: AdaliaIdAsteroidsListVariables
    }
  | {
      path: '/api/adalia_id/asteroids/{serial}/'
      operationId: 'adaliaIdAsteroidsRetrieve'
      variables: AdaliaIdAsteroidsRetrieveVariables
    }
  | {
      path: '/api/adalia_id/asteroids/alliance_control/'
      operationId: 'adaliaIdAsteroidsAllianceControlRetrieve'
      variables: AdaliaIdAsteroidsAllianceControlRetrieveVariables
    }
  | {
      path: '/api/adalia_id/asteroids/early_adopter/'
      operationId: 'adaliaIdAsteroidsEarlyAdopterRetrieve'
      variables: AdaliaIdAsteroidsEarlyAdopterRetrieveVariables
    }
  | {
      path: '/api/adalia_id/asteroids/personal/'
      operationId: 'adaliaIdAsteroidsPersonalRetrieve'
      variables: AdaliaIdAsteroidsPersonalRetrieveVariables
    }
  | {
      path: '/api/adalia_id/asteroids/summary/'
      operationId: 'adaliaIdAsteroidsSummaryRetrieve'
      variables: AdaliaIdAsteroidsSummaryRetrieveVariables
    }
  | {
      path: '/api/adalia_id/crewmates/'
      operationId: 'adaliaIdCrewmatesList'
      variables: AdaliaIdCrewmatesListVariables
    }
  | {
      path: '/api/adalia_id/crewmates/{serial}/'
      operationId: 'adaliaIdCrewmatesRetrieve'
      variables: AdaliaIdCrewmatesRetrieveVariables
    }
  | {
      path: '/api/adalia_id/crewmates/alliance_control/'
      operationId: 'adaliaIdCrewmatesAllianceControlRetrieve'
      variables: AdaliaIdCrewmatesAllianceControlRetrieveVariables
    }
  | {
      path: '/api/adalia_id/crewmates/personal/'
      operationId: 'adaliaIdCrewmatesPersonalRetrieve'
      variables: AdaliaIdCrewmatesPersonalRetrieveVariables
    }
  | {
      path: '/api/auth/users/'
      operationId: 'authUsersList'
      variables: AuthUsersListVariables
    }
  | {
      path: '/api/auth/users/{username}/'
      operationId: 'authUsersRetrieve'
      variables: AuthUsersRetrieveVariables
    }
  | {
      path: '/api/nfts/{collection}/assets/'
      operationId: 'nftsAssetsList'
      variables: NftsAssetsListVariables
    }
  | {
      path: '/api/nfts/{collection}/assets/{serial}/'
      operationId: 'nftsAssetsRetrieve'
      variables: NftsAssetsRetrieveVariables
    }
  | {
      path: '/api/nfts/{collection}/assets/alliance_control/'
      operationId: 'nftsAssetsAllianceControlRetrieve'
      variables: NftsAssetsAllianceControlRetrieveVariables
    }
  | {
      path: '/api/nfts/{collection}/assets/personal/'
      operationId: 'nftsAssetsPersonalRetrieve'
      variables: NftsAssetsPersonalRetrieveVariables
    }
  | {
      path: '/api/wallets/wallets/'
      operationId: 'walletsWalletsList'
      variables: WalletsWalletsListVariables
    }
  | {
      path: '/api/wallets/wallets/{id}/'
      operationId: 'walletsWalletsRetrieve'
      variables: WalletsWalletsRetrieveVariables
    }
